package jp.rt_net.android;

import java.text.DecimalFormat;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.ProgressBar;
import android.widget.RadioGroup;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.ToggleButton;


public class MainActivity extends Activity {
	//R}hp萔̐錾
	public static final int USBAccessoryWhat = 0;            
	
	public static final int COMMAND_OPEN_NORMAL_CONFIG  = 8;
		
	public static final int COMMAND_UPDATE_DIN  = 101;
	public static final int COMMAND_UPDATE_AIN0 = 102;
	public static final int COMMAND_UPDATE_AIN1 = 103;
	public static final int COMMAND_UPDATE_AIN2 = 104;
	public static final int COMMAND_UPDATE_AIN3 = 105;
	
	public static final int COMMAND_WRITE_DOUT    = 201;
	public static final int COMMAND_SET_PWM0_FREQ = 205;
	public static final int COMMAND_SET_PWM1_FREQ = 206;
	public static final int COMMAND_SET_PWM2_FREQ = 207;
	public static final int COMMAND_SET_PWM0_DUTY = 208;
	public static final int COMMAND_SET_PWM1_DUTY = 209;
	public static final int COMMAND_SET_PWM2_DUTY = 210;
	
	private ToggleButton tb_DOUT0;                          //DOUTsp
	private ToggleButton tb_DOUT1;
	private ToggleButton tb_DOUT2;
	private ToggleButton tb_DOUT3;
	
	private SeekBar sb_AOUT0_freq; 
	private SeekBar sb_AOUT0_duty;
	private SeekBar sb_AOUT1_freq; 
	private SeekBar sb_AOUT1_duty;
	private SeekBar sb_AOUT2_freq; 
	private SeekBar sb_AOUT2_duty;
	
	private USBAccessoryManager accessoryManager;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
        this.setContentView(R.layout.activity_main); //ʂ̃Zbg
       	accessoryManager = new USBAccessoryManager(handler, USBAccessoryWhat);	
	
    	//gO{^̒`     
        tb_DOUT0 = (ToggleButton) findViewById(R.id.toggleButton_DOUT0);
       	tb_DOUT1 = (ToggleButton) findViewById(R.id.toggleButton_DOUT1);     
     	tb_DOUT2 = (ToggleButton) findViewById(R.id.toggleButton_DOUT2);
       	tb_DOUT3 = (ToggleButton) findViewById(R.id.toggleButton_DOUT3);    
       	
       	//gO{^CheckύXꂽ̃Cxg   
       	setListenerDOUTx(tb_DOUT0);
       	setListenerDOUTx(tb_DOUT1);
       	setListenerDOUTx(tb_DOUT2);
       	setListenerDOUTx(tb_DOUT3);
	    //V[No[̒`
	    sb_AOUT0_freq = (SeekBar) findViewById(R.id.seekBar_AOUT0_freq);
	    sb_AOUT0_duty = (SeekBar) findViewById(R.id.seekBar_AOUT0_duty);
	    sb_AOUT1_freq = (SeekBar) findViewById(R.id.seekBar_AOUT1_freq);
	    sb_AOUT1_duty = (SeekBar) findViewById(R.id.seekBar_AOUT1_duty);
	    sb_AOUT2_freq = (SeekBar) findViewById(R.id.seekBar_AOUT2_freq);
	    sb_AOUT2_duty = (SeekBar) findViewById(R.id.seekBar_AOUT2_duty);   
	    //V[No[̒lύXꂽ̃Cxg 
	    setListenerSeekbar(sb_AOUT0_freq, COMMAND_SET_PWM0_FREQ);
	    setListenerSeekbar(sb_AOUT0_duty, COMMAND_SET_PWM0_DUTY);
	    setListenerSeekbar(sb_AOUT1_freq, COMMAND_SET_PWM1_FREQ);
	    setListenerSeekbar(sb_AOUT1_duty, COMMAND_SET_PWM1_DUTY);
	    setListenerSeekbar(sb_AOUT2_freq, COMMAND_SET_PWM2_FREQ);
	    setListenerSeekbar(sb_AOUT2_duty, COMMAND_SET_PWM2_DUTY);
	 
	    /****WI{^̒`****/
       	RadioGroup radioGroup = (RadioGroup) findViewById(R.id.radioGroup1);                        
        //(2)WI{^`FbNꂽƂ̃Cxg
        radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
		    public void onCheckedChanged(RadioGroup group, int checkedId) {   
		    	int freqMax = 10;
		    	//`FbNĂ郉WI{^idŃV[No[̃Wς
		    	switch(checkedId){
			    	case R.id.radio0: freqMax = 10;
			    		break;
			    	case R.id.radio1: freqMax = 100;
			    		break;
			    	case R.id.radio2: freqMax = 1000;
			    		break;	
			    	case R.id.radio3: freqMax = 10000;
			    		break;	
			    	case R.id.radio4: freqMax = 100000;
			    		break;
		    	}
		    	sb_AOUT0_freq.setMax(freqMax);
		    	sb_AOUT1_freq.setMax(freqMax);
		    	sb_AOUT2_freq.setMax(freqMax);
		    	
	       		if(handler != null) {
	       			handler.sendMessage( Message.obtain(handler,COMMAND_SET_PWM0_FREQ) );      			
	       			handler.sendMessage( Message.obtain(handler,COMMAND_SET_PWM0_DUTY) );
	       			handler.sendMessage( Message.obtain(handler,COMMAND_SET_PWM1_FREQ) );
	       			handler.sendMessage( Message.obtain(handler,COMMAND_SET_PWM1_DUTY) );
	       			handler.sendMessage( Message.obtain(handler,COMMAND_SET_PWM2_FREQ) );
	       			handler.sendMessage( Message.obtain(handler,COMMAND_SET_PWM2_DUTY) );
	       		}      
	       		
		    }        
        });	
	}

	@Override
	public void onStart() {
		super.onStart();
		this.setTitle("RT-ADKminiڑĂ܂");
	}
	
    @Override
    public void onResume() {
    	super.onResume();
        accessoryManager.enable(this,getIntent());
    }
    
	@Override
	public void onPause() {
	 	super.onPause();
	   	accessoryManager.disable(this);
	   	disconnectAccessory();
	}
	    
	public void disconnectAccessory() {
	   	this.setTitle("RT-ADKminiڑĂ܂");
	}

	/****USB ManagerXbhUȊ삩message󂯂Handler****/ 
     private Handler handler = new Handler() {
    	@Override
    	public void handleMessage(Message msg) {
        
			switch(msg.what){						
				
               //******************(3)R}hMAndroid to RTADKmini**********************//			
			   case COMMAND_OPEN_NORMAL_CONFIG:
					if(accessoryManager.isConnected() == false) {
						return;
					}
					/****MR}h̏ ****/
					byte[] commandPacket_ONC = new byte[2];
					commandPacket_ONC[0] = (byte) COMMAND_OPEN_NORMAL_CONFIG;   //0byte̓R}h̎
					commandPacket_ONC[1] = 2;                            //1byte̓pPbg
					                                                     //̃R}h2byteڈȍ~͂Ȃ
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_ONC);			
					break;
			   case COMMAND_WRITE_DOUT:
					if(accessoryManager.isConnected() == false) {
						return;
					}
					/****MR}h̏ ****/
					byte[] commandPacket_CWD = new byte[4];
					commandPacket_CWD[0] = (byte) COMMAND_WRITE_DOUT;   
					commandPacket_CWD[1] = 4;
					commandPacket_CWD[2] = 0;
					commandPacket_CWD[3] = 0;
					if(tb_DOUT0.isChecked()) {
						commandPacket_CWD[3] |= (byte)0x10;
					}	
					if(tb_DOUT1.isChecked()) {
						commandPacket_CWD[3] |= (byte)0x20;
					}	
					if(tb_DOUT2.isChecked()) {
						commandPacket_CWD[3] |= (byte)0x40;
					}	
					if(tb_DOUT3.isChecked()) {
						commandPacket_CWD[3] |= (byte)0x80;
					}	
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_CWD);			
					break;
			    case COMMAND_SET_PWM0_FREQ:
			    	byte[] commandPacket_SP0F = new byte[6];
			    	commandPacket_SP0F[0] = (byte) COMMAND_SET_PWM0_FREQ;   
					commandPacket_SP0F[1] = 6;
					commandPacket_SP0F[2] = (byte) (  0x000000ff & sb_AOUT0_freq.getProgress()       );
					commandPacket_SP0F[3] = (byte) ( (0x0000ff00 & sb_AOUT0_freq.getProgress()) >> 8 );
					commandPacket_SP0F[4] = (byte) ( (0x00ff0000 & sb_AOUT0_freq.getProgress()) >> 16);
					commandPacket_SP0F[5] = (byte) ( (0xff000000 & sb_AOUT0_freq.getProgress()) >> 24);
			    	
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_SP0F);	
					break;	
			    
                case COMMAND_SET_PWM0_DUTY:
                	byte[] commandPacket_SP0D = new byte[3];
                	commandPacket_SP0D[0] = (byte) COMMAND_SET_PWM0_DUTY;   
					commandPacket_SP0D[1] = 3;
					commandPacket_SP0D[2] = (byte) (  0x000000ff & sb_AOUT0_duty.getProgress()       );
					
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_SP0D);	
					break;	
                case COMMAND_SET_PWM1_FREQ:
			    	byte[] commandPacket_SP1F = new byte[6];
			    	commandPacket_SP1F[0] = (byte) COMMAND_SET_PWM1_FREQ;   
					commandPacket_SP1F[1] = 6;
					commandPacket_SP1F[2] = (byte) (  0x000000ff & sb_AOUT1_freq.getProgress()       );
					commandPacket_SP1F[3] = (byte) ( (0x0000ff00 & sb_AOUT1_freq.getProgress()) >> 8 );
					commandPacket_SP1F[4] = (byte) ( (0x00ff0000 & sb_AOUT1_freq.getProgress()) >> 16);
					commandPacket_SP1F[5] = (byte) ( (0xff000000 & sb_AOUT1_freq.getProgress()) >> 24);
			    	
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_SP1F);	
					break;	
			    
                case COMMAND_SET_PWM1_DUTY:
                	byte[] commandPacket_SP1D = new byte[3];
                	commandPacket_SP1D[0] = (byte) COMMAND_SET_PWM1_DUTY;   
					commandPacket_SP1D[1] = 3;
					commandPacket_SP1D[2] = (byte) (  0x000000ff & sb_AOUT1_duty.getProgress()       );
					
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_SP1D);	
					break;	
                case COMMAND_SET_PWM2_FREQ:
			    	byte[] commandPacket_SP2F = new byte[6];
			    	commandPacket_SP2F[0] = (byte) COMMAND_SET_PWM2_FREQ;   
					commandPacket_SP2F[1] = 6;
					commandPacket_SP2F[2] = (byte) (  0x000000ff & sb_AOUT2_freq.getProgress()       );
					commandPacket_SP2F[3] = (byte) ( (0x0000ff00 & sb_AOUT2_freq.getProgress()) >> 8 );
					commandPacket_SP2F[4] = (byte) ( (0x00ff0000 & sb_AOUT2_freq.getProgress()) >> 16);
					commandPacket_SP2F[5] = (byte) ( (0xff000000 & sb_AOUT2_freq.getProgress()) >> 24);
			    	
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_SP2F);	
					break;	
			    
                case COMMAND_SET_PWM2_DUTY:
                	byte[] commandPacket_SP2D = new byte[3];
                	commandPacket_SP2D[0] = (byte) COMMAND_SET_PWM2_DUTY;   
					commandPacket_SP2D[1] = 3;
					commandPacket_SP2D[2] = (byte) (  0x000000ff & sb_AOUT2_duty.getProgress()       );
					
					//R}hRT-ADKmini֑M
					accessoryManager.write(commandPacket_SP2D);	
					break;	
				
				
				//*****************************************************//	
					
				case USBAccessoryWhat:
						
					switch(((USBAccessoryManagerMessage)msg.obj).type) {
					//******************(4)R}hM RT-ADKmini to Android **********************//
					   			
					   case READ:
						    byte[] commandPacket = new byte[255]; //Mf[^̊i[p
						   
						    if(accessoryManager.isConnected() == false) {
								return;
							}
							
							while(true) {
								if(accessoryManager.available() < 2 ) {
									//ׂẴR}h2byteȏȂ̂Ńobt@2byteɂȂ甲
								    break;
								}
								accessoryManager.read(commandPacket);							
							    
								//Mf[^ϐɊi[(Ăf[^unsigned byte Ȃ̂ŃLXg)
								int cp0 = 0x000000ff & (int)commandPacket[0];   //R}h
							    int cp1 = 0x000000ff & (int)commandPacket[1];   //R}h
							    int cp2 = 0x000000ff & (int)commandPacket[2];   //f[^
								
								TextView tv ;                                   //textViewQƗpϐ
								ProgressBar pb;                                 //progressBarQƗpϐ
								
							    switch(cp0) {
									case COMMAND_UPDATE_DIN:
								        //DIN̏ԕ\pTextView̍XV
										updateTextViewDINx( (TextView)findViewById(R.id.textView_DIN0_state) , (cp2& 0x10) == 0x10 );
										updateTextViewDINx( (TextView)findViewById(R.id.textView_DIN1_state) , (cp2& 0x20) == 0x20 );
										updateTextViewDINx( (TextView)findViewById(R.id.textView_DIN2_state) , (cp2& 0x40) == 0x40 );
										updateTextViewDINx( (TextView)findViewById(R.id.textView_DIN3_state) , (cp2& 0x80) == 0x80 );										
										
										break;
									case COMMAND_UPDATE_AIN0:
										tv = (TextView)findViewById(R.id.textView_AIN0);
										tv.setText("AIN0 "+ calcAINxVolt(cp2) +"V");
										pb = (ProgressBar)findViewById(R.id.progressBar_AIN0);
										pb.setProgress(cp2);
										break;
                                    case COMMAND_UPDATE_AIN1:
                                    	tv =  (TextView)findViewById(R.id.textView_AIN1);
                                    	tv.setText("AIN1 "+ calcAINxVolt(cp2) +"V");
                                    	pb = (ProgressBar)findViewById(R.id.progressBar_AIN1);
										pb.setProgress(cp2);
                                    	break;
                                    case COMMAND_UPDATE_AIN2:
                                    	tv =  (TextView)findViewById(R.id.textView_AIN2);
                                       	tv.setText("AIN2 "+ calcAINxVolt(cp2) +"V");
                                       	pb = (ProgressBar)findViewById(R.id.progressBar_AIN2);
										pb.setProgress(cp2);
                                       	break;
                                    case COMMAND_UPDATE_AIN3:
                                    	tv =  (TextView)findViewById(R.id.textView_AIN3);
                                     	tv.setText("AIN3 "+ calcAINxVolt(cp2) +"V");
                                     	pb = (ProgressBar)findViewById(R.id.progressBar_AIN3);
										pb.setProgress(cp2);
                                     	break;
							    }
							}
						//*****************************************************//
						case CONNECTED:
							break;
						case READY:
							setTitle("RT-ADKminiڑ܂");
							//RTADKminĩsRtBM[VI
							Message update = Message.obtain(handler,COMMAND_OPEN_NORMAL_CONFIG );
							if(handler != null) {
								handler.sendMessage(update);      			
							}      
							break;
						case DISCONNECTED:
							disconnectAccessory();
							break;
					    default: 
					    	break;
					}				
					
	   				break;
				default:
					break;
			} //switch
    	} //handleMessage
    }; //handler
    
    /**** DOUT̃gO{^ꂽ̏[****/ 
	private void setListenerDOUTx(ToggleButton tb_DOUTx) {
    	tb_DOUTx.setOnCheckedChangeListener(new OnCheckedChangeListener() {             	
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {            
				/****{^Ƃ̏ɏ****/          
		        if(isChecked == true)buttonView.setBackgroundColor(0x3300ff00);
		        else buttonView.setBackgroundColor(0x33ff0000);
		        //HandlerMessage𑗂
			    Message update = Message.obtain(handler,COMMAND_WRITE_DOUT );
       			if(handler != null) {
       				handler.sendMessage(update);      			
       			}      
       		}    
     	});
     
    }
    
    /**** DIN̍XV󂯎̏****/
    private void updateTextViewDINx(TextView tv ,boolean state) {
    	if(state == true) { 
		    tv.setText("High");		
		    tv.setBackgroundColor(0x3300ff00);
		}
		else {
			tv.setText("Low");			
			tv.setBackgroundColor(0x33ff0000);			
		}


    }

    /**** dɕϊ****/
    private String calcAINxVolt(int data) {
    	double Voltage;
		DecimalFormat decimalFormat1 = new DecimalFormat("0.0000");
        String VoltForm;
        Voltage = 3.3 * (0x000000FF & (int)(data) )/ 255.0;
		VoltForm = decimalFormat1.format(Voltage);

		return VoltForm;  
    }

    /**** AOUT̃V[No[̒lXVꂽ̏****/
    private void setListenerSeekbar(SeekBar sb, final int command){
    	 sb.setOnSeekBarChangeListener(  
 	            new OnSeekBarChangeListener() {  
 	            	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromTouch) {           		 
                	    Message update = Message.obtain(handler, command);          	    
                	    TextView tv;
                	    if(handler != null) {
             				handler.sendMessage(update);
             		    }	
                	    //gduty̕\𐮌`
                	    DecimalFormat decimalFormat1 = new DecimalFormat("000000");
 	                    DecimalFormat decimalFormat2 = new DecimalFormat("000.0");
                	    String freq;
 	                    String duty;
                	    String num;
 	                    double dutyCalc;
 	                    switch(command){
	 	                    case COMMAND_SET_PWM0_FREQ:
	 	                        tv = (TextView) findViewById(R.id.textView_AOUT0);
	 	                        freq = decimalFormat1.format(sb_AOUT0_freq.getProgress());
	 	 	                    dutyCalc = 100.0 * (sb_AOUT0_duty.getProgress()/255.0);
	 	                        num = "0";
	 	 	                    break;
	 	                    case COMMAND_SET_PWM0_DUTY:
	 	                    	tv = (TextView) findViewById(R.id.textView_AOUT0);
	 	                        freq = decimalFormat1.format(sb_AOUT0_freq.getProgress());
	 	 	                    dutyCalc = 100.0 * (sb_AOUT0_duty.getProgress()/255.0);
	 	                    	num = "0";
	 	 	                    break;
	 	                    case COMMAND_SET_PWM1_FREQ:
	 	                    	tv = (TextView) findViewById(R.id.textView_AOUT1);
	 	                    	freq = decimalFormat1.format(sb_AOUT1_freq.getProgress());
	 	 	                    dutyCalc = 100.0 * (sb_AOUT1_duty.getProgress()/255.0);
	 	                    	num = "1";
	 	 	                    break;
		                    case COMMAND_SET_PWM1_DUTY:
		                    	tv = (TextView) findViewById(R.id.textView_AOUT1);
		                    	freq = decimalFormat1.format(sb_AOUT1_freq.getProgress());
	 	 	                    dutyCalc = 100.0 * (sb_AOUT1_duty.getProgress()/255.0);
		                    	num = "1";
	 	 	                    break;
		                    case COMMAND_SET_PWM2_FREQ:
		                    	tv = (TextView) findViewById(R.id.textView_AOUT2);
		                    	freq = decimalFormat1.format(sb_AOUT2_freq.getProgress());
	 	 	                    dutyCalc = 100.0 * (sb_AOUT2_duty.getProgress()/255.0);
		                    	num = "2";
	 	 	                    break;
	 	                    case COMMAND_SET_PWM2_DUTY:
	 	                    	tv = (TextView) findViewById(R.id.textView_AOUT2);
	 	                    	freq = decimalFormat1.format(sb_AOUT2_freq.getProgress());
	 	 	                    dutyCalc = 100.0 * (sb_AOUT2_duty.getProgress()/255.0);
	 	                    	num = "2";
	 	 	                    break;
 	                        default: 
 	                        	tv = null;
 	                            dutyCalc = 0.0;
 	                        	freq = null;
 	                            duty = null;
 	                        	num = null;
 	                            break;
 	                    }
 	                    
 	                   
 	                    duty = decimalFormat2.format(dutyCalc);
 	                    tv.setText("AOUT"+ num +"  freq :" + freq + "Hz duty :"+ duty +"% ");
 	            	
 	            	}  	                 
 	                public void onStartTrackingTouch(SeekBar seekBar) {  
 	                }  	          
 	                public void onStopTrackingTouch(SeekBar seekBar) {  
 	                }  
 	            }  
 	    );  
    	
    }	
}    
